#!/bin/bash

function die {
  echo "ERROR: $@" > /dev/stderr
  exit 1
}

awk '' || die "awk is not installed on your system! Please install it and try again."

function strip {
  awk '{print $1}'
}

function check_file {
  [[ -f "$1" ]] || die "File not found: '$1'"
}

OUT=$(./2.2.test)
EXPECTED="Circle
Circle: area=283.528737"

if [[ "$OUT" = "$EXPECTED" ]]; then
  echo "SUCCESS"
else
  echo "FAILED: Expected: '$EXPECTED', and instead, got '$OUT'"
  exit 1
fi
